.nolist
include \masm32\include\masm32rt.inc
include \masm32\include\CpuId.inc
include \masm32\macros\timers.asm

.686
.xmm

markl_CountFileLines	PROTO: DWORD
CompteurLignes		PROTO: DWORD, :DWORD
getlines		PROTO: DWORD, :DWORD
getlinesJJ		PROTO: DWORD, :DWORD

	LOOP_COUNT = 2000

.data?
cbFile	dd ?
hFile	dd ?
Win$	dd ?
bytesread	dd ?

.data
wininc	db "\masm32\include\windows.inc", 0

crlf	equ 13, 10

align 16
gltestA	db "A test string", crlf
	db "This is string A", crlf
	db "This is a BAD string B", 10
	REPEAT 100-3
	db "This is a test string", crlf
	ENDM
	db "This is a BAD test string", 10
	db "This is a really, really good test string", crlf, 0	; end of string - 100 valid lines

	db crlf, crlf, crlf, crlf, crlf, crlf
	
align 16
gltestB	db "B test string", crlf
	db "This is string A", crlf
	db "This is a BAD string B", 10
	db "This is BAD string C", 10
	db "And BAD string D", 10
	db "This is string B", crlf
	db "And BAD E", 10
	REPEAT 100-5
	db "This is a test string", crlf
	ENDM
	db "This is a BAD test string", 10
	db "This is a good test string", crlf
	db "This is a BAD test string", 10
	db "This is a test string", crlf, 0	; end of string - 100 valid lines

	db crlf, crlf, crlf, crlf, crlf, crlf

.code

start:
	invoke ShowCPU, 1
	print chr$(13, 10, "Tests for correctness - 2*100 lines expected:", 13, 10)
	print "Mark Larson=",9
	; invoke markl_CountFileLines, offset gltestA ;, len(offset gltestA)
	print "- / "
	; invoke markl_CountFileLines, offset gltestB ;, len(offset gltestB)
	print " - (throws exception)", 13, 10
	print "jj2007=      ",9
	invoke getlinesJJ, offset gltestA, len(offset gltestA)
	print str$ (eax), " / "
	invoke getlinesJJ, offset gltestB, len(offset gltestB)
	print str$ (eax), " lines", 13, 10
	print "Lingo=      ",9
	invoke getlines, offset gltestA, len(offset gltestA)
	print str$ (eax), " / "
	invoke getlines, offset gltestB, len(offset gltestB)
	print str$ (eax), " lines", 13, 10
	print "ToutEnMasm=",9
	invoke CompteurLignes, offset gltestA, len(offset gltestA)
	print str$ (eax), " / "
	invoke CompteurLignes, offset gltestB, len(offset gltestB)
	print str$ (eax), " lines", 13, 10, 10

	mov eax, alloc$(1000000)
	and eax, -16	; Lingo's code chokes for data not aligned to a 16 bytes boundary
	mov Win$, eax
	print "Counting lines of "
	print offset wininc, ":", 13, 10, 10
	mov hFile, fopen(offset wininc)
	mov cbFile, fsize(eax)
	invoke ReadFile, hFile, Win$, cbFile, offset bytesread, 0
	fclose hFile

	print "markl_CountFileLines (Mark Larson):", 13, 10
	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
		invoke markl_CountFileLines, Win$
		mov esi, eax
	counter_end
	shr eax, 10
	print str$(eax), 9, "kilocycles for "	; 33000 cycles on P4, 49000 unaligned; 5000 for 16k... a factor 5???
	print str$(esi), " lines, "
	print str$(cbFile), " bytes", 13, 10, 10

	print "getlinesJJ: (jj2007)", 13, 10
	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
		invoke getlinesJJ, Win$, cbFile
		mov esi, eax
	counter_end
	shr eax, 10
	print str$(eax), 9, "kilocycles for "	; 33000 cycles on P4, 49000 unaligned; 5000 for 16k... a factor 5???
	print str$(esi), " lines, "
	print str$(cbFile), " bytes", 13, 10, 10
	if 1
	print "getlines (Lingo):", 13, 10
	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
		invoke getlines, Win$, cbFile
		mov esi, eax
	counter_end
	shr eax, 10
	print str$(eax), 9, "kilocycles for "	; 33000 cycles on P4, 49000 unaligned; 5000 for 16k... a factor 5???
	print str$(esi), " lines, "
	print str$(cbFile), " bytes", 13, 10, 10
	endif
	if 1
	print "CompteurLignes: (ToutEnMasm)", 13, 10
	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
		invoke CompteurLignes, Win$, cbFile
		mov esi, eax
	counter_end
	shr eax, 10
	print str$(eax), 9, "kilocycles for "	; 33000 cycles on P4, 49000 unaligned; 5000 for 16k... a factor 5???
	print str$(esi), " lines, "
	print str$(cbFile), " bytes", 13, 10, 10
	endif

	inkey "Hit any key"
	exit

OPTION PROLOGUE:none
OPTION EPILOGUE:none
markl_CountFileLines proc src:DWORD	; [url=http://www.masm32.com/board/index.php?topic=5434.msg40666#msg40666]Mark Larson[/url]
  mov eax,0a0a0a0ah

  movd xmm7,eax
  mov edx, [esp+4]	; Win$	; offset [pFilebuffer]
  pshufd xmm7,xmm7,00000000b
  mov ecx, [cbFile]

  pxor xmm6, xmm6

  shr ecx,11 ;divide by 128*16
  jnc evenly_divisible
  inc ecx
evenly_divisible:

@@:
  pxor xmm5, xmm5
  ;i think it is the unrolling that is hosing things.
  i = 0
  WHILE i LT (16*128)
	movdqu xmm0, [edx + i +  0]
	movdqu xmm1, [edx + i + 16]
	movdqu xmm2, [edx + i + 32]
	movdqu xmm3, [edx + i + 48]

	pcmpeqb xmm0, xmm7
	pcmpeqb xmm1, xmm7
	pcmpeqb xmm2, xmm7
	pcmpeqb xmm3, xmm7

	paddb xmm0, xmm1
	paddb xmm2, xmm3

	paddb xmm0, xmm2

	; can't you do this step outside the loop?  I am pretty sure you can.
	psubb xmm5, xmm0 ; total 128*8 max = 1K
	i=i+16*4
  ENDM

; unpack MM5 to get sum in 1K block
pxor xmm0, xmm0
psadbw xmm5, xmm0
paddd xmm6, xmm5

dec ecx
lea edx, [edx + 128*16]
jne @B

movd eax, xmm6
psrldq xmm6,8 ;shift Right 8 bytes
movd ebx, xmm6
add eax, ebx
ret 4
markl_CountFileLines ENDP

OPTION PROLOGUE:PrologueDef
OPTION EPILOGUE:EpilogueDef

CompteurLignes PROC uses ebx edi esi pmem:DWORD,taille:DWORD
			local  theEnd:dword,retenue:DWORD
			Local  retour:DWORD
.data
	sse2entree 	db 13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,0 
	sse2line	db 10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,0
.code
	;init of various register
	mov retenue,0
	lea eax,sse2entree
	movups xmm6,[eax]
	lea eax,sse2line
	movups xmm7,[eax]
	mov eax,pmem
	add eax,taille
	mov theEnd,eax
	mov edx,pmem
	mov eax,0	;line counter
	;ready
	NewBloc:
	if 0	; new version, to be completed
		movups xmm1,[edx]		;load 16 bytes
		movups xmm2,[edx+1]	;decale of 1
		pcmpeqb xmm1,xmm6	;13 ,xmm1 modified
		pcmpeqb xmm2,xmm7	;10 ,xmm2 modified
		pand xmm1,xmm2		;et logique FF et 00 = 0,result in xmm1
		pmovmskb ecx, xmm1	; result for 13,10 in ecx
		@@:
		mov edi,0			;take care with undeterminate state
		bsf edi,ecx		;search the 13,10
		.if edi == 0 && ecx != 0
			btr ecx,edi	;delet the bit find in edx,10
			inc eax		;inc the number of lines
		.elseif edi != 0
			btr ecx,edi	;delet the bit find in edx,10
			inc eax
		.endif
		.if ecx != 0
			jmp @B
		.endif
	else
	mov edx,pmem
	movups xmm1,[edx]			;load 16 bytes
	movups xmm2,[edx]			;charger les mmes 16 bytes
	pcmpeqb  xmm1,xmm6		;13 ,xmm1 modified
	;ff 00 ff 00 ff 00 ff 00-00 00 00 00 00 00 00 00  ;example of modified xmm1 in the dugger
	pcmpeqb  xmm2,xmm7		;10 ,xmm2 modified	
	;00 ff 00 ff 00 ff 00 ff-00 00 00 00 00 00 00 00  ;modified xmm2
	;--------- debug ---------
	;lea edx,TamponVisu1		;just here to view the result in the debugger
	;movups [edx],xmm1
	;lea edx,TamponVisu2	
	;movups [edx],xmm2		
	;-------- debug ------------------
	;the ;ff 00 ff .... must be read right to left
	;ecx and edx must be read left to right
	pmovmskb ecx, xmm1 ;1010101	;result for 13 in ecx  
	pmovmskb edx, xmm2 ;10101010	;result for 10 in edx
	;each 13 are now only  a  bit in ecx
	;each 10 are now only a bit in edx 
	;---------- search for bits and there positions -------
	;instructions are internal and very fast
	;ecx and edx have now her bits set to 1 as the same position 

	endif
	
	.if retenue == 1
		;the last 16 bytes loaded was ended by a 13,bit 15
		;Test if bit zero is one (there is a 10)
		bsf  edi,edx		;search the 10
		.if edi == 0 && edx != 0	
			btr edx,edi			;delet the bit find in edx,10
			inc eax			;inc the number of lines
		.endif				
	.endif
	NewEntree:
	bsf	ebx,ecx			;give the position of one bit at 1
	.if ebx == 0 && ecx != 0
		;le bit zero est a 1
		jmp bitzero13a1
	.endif
	.if ebx				;not zero ,on a un 13			
		bitzero13a1:
		btr ecx,ebx			;efface le bit trouv dans ecx
		.if ebx != 15
			inc ebx		      ;incrmente sa positon pour la comparer au 10
		.elseif
			mov retenue,1	;le 10 va se trouver dans le chargement suivant
			jmp NewSeriede16
			;suite a voir
		.endif
		
		traiteretenue:
		bsf  edi,edx		;cherche le 0A
		.if edi == 0 && edx != 0
			;le bit zero des 10 est a 1
			jmp bitzero10a1
		.endif
		.if  edi
			bitzero10a1:
			btr edx,edi			;efface le bit trouv dans edx,10			
			.if ebx == edi	;un 10 suit immdiatement le 13		
				inc eax	;////////// inc the number of lines /////////////////
			.elseif ebx >edi
				;this 10 is alone
				;c'est un 10 isol avant le 13 ,HTML
				mov edi,0
				jmp traiteretenue 
			.endif
		.endif
		;------ conditions de rebouclage ---------------
		.if ecx != 0
			mov ebx,0		;avoid an undeterminated state
			mov edi,0
			jmp NewEntree
		.endif
	.endif
	NewSeriede16:
	mov edx,pmem
	add edx,16	
	mov pmem,edx
	.if edx < theEnd
		jmp NewBloc
	.endif

 FindeCompteurLignes:
         ret
CompteurLignes endp

OPTION PROLOGUE:none
OPTION EPILOGUE:none

align 16
db 8Dh, 0A4h, 24h, 0,0,0,0, 8Dh, 0A4h, 24h, 0, 0, 0,0,0
getlines proc pBuffer : dword, nSize:dword
	pop ecx		; ecx -> return address
	mov edx, 0a0a0a0ah		; 0Ah->second byte to looking for
	pop eax		; eax->pBuffer-> eax->16 bytes aligned !!!
	movd xmm0, edx		; edx = 0a0a0a0ah
	mov [esp-4],esi		; preserve esi register
	pop esi		; esi -> size of buffer
	mov [esp-4], ebx		; preserve ebx register
	add esi, eax		;
	pshufd xmm0, xmm0, 0		; xmm0=0a0a0a0a0a0a0a.....
	movdqa xmm1, xmm0		; xmm1=xmm0=0a0a0a0a0a0a0a.....
	xor ebx, ebx		; ebx->counter=0

;Fast part - 1-> looking for 0Ah simbol in next 16 bytes
LoopA:
	cmp eax, esi		; Is it End of Buffer?
	jg ExLoop		; Yes, exit
	pcmpeqb xmm0, [eax]		; [eax]->16bytes aligned!!!
	add eax, 16		; next qword
	pmovmskb ecx, xmm0		; test mask for zero
	movdqa xmm0, xmm1		; xmm0=xmm1=0a0a0a0a0a0a0a.....
	test ecx, ecx		; if zero loop again
	jnz Loli

;Fast part - 2
	cmp eax, esi		; Is it End of Buffer?
	jg ExLoop		; Yes, exit
	pcmpeqb xmm0, [eax]		; [eax]->16bytes aligned!!!
	add eax, 16		; next qword
	pmovmskb ecx, xmm0		; test mask for zero
	movdqa xmm0, xmm1		; xmm0=xmm1=0a0a0a0a0a0a0a.....
	test ecx, ecx		; if zero loop again
	jz LoopA		; if not zero found 0Ah simbol

;Slow part-2
	bsf edx, ecx
	cmp word ptr [edx+eax-17], 0A0Dh
	jne @f
	add ebx, 1		; inc counter
@@:
	btr ecx, edx		; clear bit
	test ecx, ecx		; is there more bits?
	je LoopA		; no, loop again
	bsf edx, ecx		; Yes, more...
	cmp word ptr [edx+eax-17], 0A0Dh
	jne @b
	add ebx, 1		; inc counter
	jne @b

align 16
;Slow part-1
Loli:
	bsf edx, ecx
	cmp word ptr [edx+eax-17], 0A0Dh
	jne @f
	add ebx, 1		; inc counter
@@:
	btr ecx, edx		; clear bit
	test ecx, ecx		; is there more bits?
	je LoopA		; no, loop again
	bsf edx, ecx		; Yes, more...
	cmp word ptr [edx+eax-17], 0A0Dh
	jne @b
	add ebx, 1		; inc counter
	jne @b

;End
align 16
ExLoop:
	mov esi, [esp-8]
	mov eax, ebx
	mov ebx, [esp-4]
	jmp dword ptr [esp-12]
getlines endp

getlinesJJ proc src:DWORD, ct:DWORD	; with some inspiration from Lingo, NightWare and Agner Fog
	mov eax, 0a0a0a0ah	; Ascii 10, linefeed
;	int 3
	movd xmm2, eax
	pshufd xmm2, xmm2, 0	; linefeeds for comparison in xmm2
	mov eax, [esp+4]		; src
	push esi
	mov esi, [esp+12]		; len(buffer)
	push ecx			; all registers preserved, except eax = return value
	push edx
	push ebx
	; push edi
	add esi, eax		; esi = src + len(buffer)
	xor ebx, ebx		; line counter

	movups xmm1, [eax]	; move 16 bytes into xmm1, unaligned (adapted from Lingo/NightWare)
	pcmpeqb xmm1, xmm2	; set bytes in xmm1 to FF if linefeeds (2nd operand) found in xmm1
	mov edx, eax		; save pointer to string
	pmovmskb eax, xmm1	; set byte mask in eax
@@:	.Repeat
		bsf ecx, eax	; bit scan forward
		je @F		; no 0A in first 16 bytes, we are done here
		btr eax, ecx	; clear that bit
		inc ebx
		cmp byte ptr [edx+ecx-1], 13
	.Until !Zero?
	dec ebx			; that was an error!
	jmp @F

@@:	and edx, -16		; align initial pointer to 16-byte boundary
	lea eax, [edx+16]		; aligned pointer + 16 (first 0..15 dealt with by movups above)

	.Repeat
@@:	; pcmpeqb resets xmm0 to zero - we must reload it!
	movdqa xmm0, xmm2	; linefeeds in xmm0 & xmm1
	pcmpeqb xmm0, [eax]	; compare packed bytes in [m128] and xmm0 for equality
	pmovmskb edx, xmm0	; set byte mask in edx for first 16 byte chunk

	movdqa xmm0, xmm2	; linefeeds in xmm0 & xmm1
	pcmpeqb xmm0, [eax+16]	; compare packed bytes in [m128] and xmm0 for equality
	pmovmskb ecx, xmm0	; set byte mask in edx for second 16 byte chunk

	shl ecx, 16
	lea eax, [eax+32]		; len counter (moving up lea or add costs 3 cycles for the 191 byte string)
	cmp eax, esi		; test boundary
	jae L1
	or edx, ecx
	jz @B

@@:	bsf ecx, edx	; bit scan forward
	je @F		; no 0A in first 16 bytes, we are done here
	inc ebx
	btr edx, ecx	; clear that bit
	cmp byte ptr [eax+ecx-33], 13
	je @B
	dec ebx			; that was an error!
	jmp @B
@@:	.Until 0
L1:	; int 3
	mov ecx, eax
	sub eax, 32
	sub ecx, esi
	mov esi, eax
	.Repeat
		lodsb
		test al, al
		je @F
		.if al==10
			mov al, [esi-2]
			.if al==13
				inc ebx
			.endif
		.endif
		dec ecx
	.Until 0
@@:	mov eax, ebx
	; pop edi
	pop ebx
	pop edx
	pop ecx
	pop esi
	ret 8
getlinesJJ endp

end start
OxPT_Linker	polink	; delete the red x if you want to use Pelle's linker
OPT_WAIT	0	; 1=wait until a key is pressed before closing the DOS box
OPT_Assembler	ml
OPT_DelTmp	0
OPT_Tmp2Asm	1
